//+------------------------------------------------------------------+
//|                                            Check_OrderLevels.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
//---     
#include <Trade\Trade.mqh>
CTrade trade;
#include <Trade\Trade.mqh>
//---     
#include <Trade\OrderInfo.mqh>
COrderInfo orderinfo;
//---     
#include <Trade\PositionInfo.mqh>
CPositionInfo positioninfo;
//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+
bool OrderModifyCheck(ulong ticket,double price,double sl,double tp)
  {
//---    
   if(orderinfo.Select(ticket))
     {
      //---     ,     
      string symbol=orderinfo.Symbol();
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
      //---  -      
      bool PriceOpenChanged=(MathAbs(orderinfo.PriceOpen()-price)>point);
      //---  -      StopLoss
      bool StopLossChanged=(MathAbs(orderinfo.StopLoss()-sl)>point);
      //---  -      Takeprofit
      bool TakeProfitChanged=(MathAbs(orderinfo.TakeProfit()-sl)>tp);
      //---   -   
      if(PriceOpenChanged || StopLossChanged || TakeProfitChanged)
         return(true);  //         
      //---    , StopLoss  Takeprofit 
      else
      //---   
         PrintFormat(" #%d    Open=%.5f SL=.5f TP=%.5f",
                     ticket,orderinfo.PriceOpen(),orderinfo.StopLoss(),orderinfo.TakeProfit());
     }
//---   ,    
   return(false);       //    
  }
//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+
bool PositionModifyCheck(ulong ticket,double sl,double tp)
  {
//---    
   if(positioninfo.SelectByTicket(ticket))
     {
      //---     ,     
      string symbol=positioninfo.Symbol();
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      //---  -      StopLoss
      bool StopLossChanged=(MathAbs(positioninfo.StopLoss()-sl)>point);
      //---  -      Takeprofit
      bool TakeProfitChanged=(MathAbs(positioninfo.TakeProfit()-sl)>tp);
      //---   -   
      if(StopLossChanged || TakeProfitChanged)
         return(true);  //         
      //---    StopLoss  Takeprofit 
      else
      //---   
         PrintFormat(" #%d    Open=%.5f SL=.5f TP=%.5f",
                     ticket,orderinfo.StopLoss(),orderinfo.TakeProfit());
     }
//---   ,    
   return(false);       //    
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---      
   double priceopen,stoploss,takeprofit;
//---     
   ulong orderticket,positionticket;
/*
   ...       StopLoss/Takeprofit/PriceOpen
*/
//---         
   if(OrderModifyCheck(orderticket,priceopen,stoploss,takeprofit))
     {
      //---   
      trade.OrderModify(orderticket,priceopen,stoploss,takeprofit,
                        orderinfo.TypeTime(),orderinfo.TimeExpiration());
     }
/*
   ...       StopLoss/Takeprofit
*/
//---     
   if(PositionModifyCheck(positionticket,stoploss,takeprofit))
     {
      //---   
      trade.PositionModify(positionticket,stoploss,takeprofit);
     }
//---
  }
//+------------------------------------------------------------------+
